'--------------------------------------------------------------------------------------
'name                     : CalibrateInternalRCOscillatorATmega169.inc
'programmed by            : Claus Kuhnel
'date                     : 2008-07-14
'purpose                  : Calibrate Internal RC Oscillator on AVR Butterfly
'micro                    : ATmega169
'tested with              : V.1.12.0.0 (2010-10-20)
'suited for demo          : yes
'commercial addon needed  : no
'--------------------------------------------------------------------------------------
Const I1 = &H40
Const I2 = &H70                                             ' &H45 was read out value
Const Count = 6103
Const Timer2counts = 200

Dim Osccal_opt As Byte
Dim Tmp1 As Word
Dim Tmp2 As Integer
Dim Minimum As Integer : Minimum = 32767

'Timerinit
   Ocr2a = Timer2counts                                     ' Count value for Timer2
   Set Assr.as2                                             ' 32 kHz Clock for Timer2
   Set Tccr2a.wgm21                                         ' Timer2 CTC Mode, OC2A disconnected.
   Set Tccr1b.wgm12


For I = I1 To I2
   Osccal = I                                               ' set Oscillator Calibration Register
   Tcnt1 = 0 : Tcnt2 = 0
   Set Tccr2a.cs20                                          ' Timer2 no Prescaler     -> Start
   Set Tccr1b.cs11                                          ' Counter1 Prescaler = 8  -> Start
   Do
   Loop Until Tifr2.ocf2a = 1
   Tmp1 = Tcnt1
   Reset Tccr2a.cs20                                        ' Timer2                  -> Stop
   Reset Tccr1b.cs11                                        ' Counter1                -> Stop
   Set Tifr2.ocf2a
   Tmp2 = Tmp1 - Count
   Tmp2 = Abs(tmp2)
   If Tmp2 < Minimum Then
      Minimum = Tmp2
      Osccal_opt = I
   End If
Next
Osccal = Osccal_opt


