$regfile = "8515def.dat"
$crystal = 3690000                      ' Baudrate fr STK500
$baud = 9600

Const Esc = 27

Dim Count As Word
Dim I As Byte
Dim Key As Byte

Ddrb = &B00000011                       ' Portb.0 und Portb.1 sind Ausgang
Portb = &B00000011                      ' Eingnge sind hochohmig

Led0 Alias Portb.0

On Aci Aci_isr                          ' ACI Interrupt Vektor
On Ovf1 Timer1_isr                      ' Timer1 OVF1 Interrupt Vektor

Config Aci = On                         ' Konfiguration Analog Komparator
Config Timer1 = Timer , Prescale = 256 ' Konfiguration Timer1

Start Ac                                ' Enable Analog Comparator

Enable Aci
Enable Timer1
Enable Interrupts

Gosub Charge                            ' Lade Kondensator bis Komparatorschwelle

Do
  Incr I                                ' Inkrementiere Index
  Print "I: " ; I ; " Count: " ; Timer1 ' Drucke Index und Timer1
  Waitms 100                            ' Warte 0.1 Sekunde
  Key = Inkey()
  If Key = Esc Then Gosub Charge        ' neuer Ladevorgang?
Loop

Stop Ac                                 ' Disable Analog Comparator
End

Charge:                                 ' Lade Kondensator
  I = 0 : Timer1 = 0
  Config Pinb.2 = Output
  Led0 = 0                              ' Schalte LED ein
  Waitms 100                            ' Entladezeit 100 ms
  Led0 = 1                              ' Schalte LED aus
  Config Pinb.2 = Input
  Start Timer1                          ' Timer1 starten
  Return

Aci_isr:                                ' Komparatorschwelle erreicht
  Stop Timer1
  Return

Timer1_isr:                             ' Timer1 Overflow
  Print "Timer1 Overflow"
  Stop Timer1
  Return