'------------------------------------------------------------------------------------
'name                     : adc2sS.bas
'programmed by            : Claus Kuhnel
'date                     : 2008-12-28
'purpose                  : Single-ended  AD conversion using int. reference voltage
'                           Free Runnung Mode
'micro                    : ATmega32
'tested with              : V.1.12.0.0 (2010-08-08)
'suited for demo          : yes
'commercial addon needed  : no
'------------------------------------------------------------------------------------
$regfile = "m32def.dat"
$crystal = 14745600
$baud = 19200

$include "init_staver24.bas"

Const Bandgap = &B11110                 ' MUX address for bandgap reference

Dim Result As Word
Dim Temp As Word
Dim Voltage As Single
Dim Reference As Single
Dim S As String * 10

Declare Function Readadc() As Word   ' read ADC result from ADCH & ADCL

' Configuration of ADC for free running mode
Admux = &H5E                        ' AVCC is reference, bandgap is measured
Adcsra = &HA7                                               ' prescaler 128, ADC enabled, auto trigger
'Sfior = 0                       ' free running mode (default after reset)

Adcsra = Adcsra Or &H40                                     ' start first AD conversion

Reference = 5.0                         ' Reference voltage is AVCC

Do
  Result = Readadc()
  Print "ADC  = " ; Hex(result) ; Spc(3);

  Voltage = Result * Reference
  Voltage = Voltage / 1024

  S = Fusing(voltage , " #.###")
  Print "Vref = " ; S ; " V"

Loop

End

Function Readadc()                      ' read ADC result from ADCH & ADCL
  Local W1 As Word
  Local W2 As Word

  W1 = Adcl                                                 ' read Lo byte first
  W2 = Adch                             ' read Hi byte afterwards
  Shift W2 , Left , 8
  Readadc = W1 + W2
End Function