$regfile = "m8def.dat"                  ' ATmega8
$crystal = 3686400                      ' fr STK500
$baud = 19200

Const Phone1 = "+49351xxxxxx8"          ' zu whlende Telefonnummern
Const Phone2 = "+49351xxxxxx9"
Const Message1 = "S1 offen"            ' zu versendende Mitteilungen
Const Message2 = "S2 offen"

Const True = 1
Const False = 0

Const Instruct = 254
Const Setcursor = 71                    ' [x] [y]
Const Cursorhome = 72
Const Cleardisplay = 88

Dim Phone As String * 15
Dim Message As String * 10
Dim Rc_string As String * 20
Dim Status As Byte
Dim Error As Byte
Dim M1_sent As Bit
Dim M2_sent As Bit

Open "Comb.0:19200,8,N,1,inverted" For Output As #1  ' PB0 ist ser. Ausgang
Wait 1
Print #1 , Chr(instruct) ; Chr(cleardisplay);
Print #1 , "Initialisierung"

Config Pind.2 = Input                   ' S1
Config Pind.3 = Input                   ' S2
Config Pind.7 = Input                   ' S3
Portd = 255                             ' PullUp aktiv

Config Serialin = Buffered , Size = 40  ' Konfig. der ser. Eingabe
Enable Interrupts

Print #1 , Chr(instruct) ; Chr(cleardisplay);
Print #1 , "Anlage scharf..."
M1_sent = False
M2_sent = False

Do
   If Pind.2 = 0 Then
      If M1_sent <> True Then
         Print #1 , Chr(instruct) ; Chr(setcursor) ; Chr(1) ; Chr(3);
         Print #1 , "S1 offen      ";
         Phone = Phone1
         Message = Message1
         Gosub Send_message
      End If
   Else
      M1_sent = False
      Print #1 , Chr(instruct) ; Chr(setcursor) ; Chr(1) ; Chr(3);
      Print #1 , "S1 geschlossen";
   End If
   If Pind.3 = 0 Then
      If M2_sent <> True Then
         Print #1 , Chr(instruct) ; Chr(setcursor) ; Chr(1) ; Chr(4);
         Print #1 , "S2 offen      ";
         Phone = Phone2
         Message = Message2
         Gosub Send_message
      End If
   Else
      M2_sent = False
      Print #1 , Chr(instruct) ; Chr(setcursor) ; Chr(1) ; Chr(4);
      Print #1 , "S2 geschlossen";
   End If
   If Pind.7 = 0 Then Exit Do
   Waitms 500
Loop

Print #1 , Chr(instruct) ; Chr(cleardisplay);
Print #1 , "Anlage"
Print #1 , "ausser Betrieb.";
Goto Eop

Send_message:
   Print "ATZ"            ' Initialisiere Modem mit Werkseinstellung
   Input Rc_string                     ' Warte auf Antwort vom Modem
   Status = Instr(rc_string , "OK")  ' hat Modem mit OK geantwortet?
   If Status = 0 Then
      Print #1 , "Connection failed."
      Goto Repeat
   End If

   Print "ATE"                          ' Echo ausschalten
   Input Rc_string                     ' Warte auf Antwort vom Modem
   Status = Instr(rc_string , "OK")  ' hat Modem mit OK geantwortet?
   If Status = 0 Then
      Print #1 , "Connection failed."
      Goto Repeat
   End If

   Wait 2

   Print "ATDT";
   Print Phone                          ' Whle Telefonnummer
   Input Rc_string
   Status = Instr(rc_string , "CONNECT")' hat Modem mit CONNECT geantwortet?
   If Status = 0 Then
      Print #1 , "Connection failed."
      Goto Repeat
   End If

   Wait 2

   Print Message                        ' Sende Mitteilung

   Wait 3                           ' wird fr +++ Kommando bentigt
   Print "+++"                      ' Umschalten in Kommandomode
   Wait 2                           ' wird fr +++ Kommando bentigt

   Print "ATH"                          ' Unterbrechen der Verbindung
   Input Rc_string                     ' Warte auf Antwort vom Modem
   Status = Instr(rc_string , "OK")  ' hat Modem mit OK geantwortet?
   If Status = 0 Then
      Print #1 , "Connection failed."
      Goto Repeat
   End If
   If Message = Message1 Then
      M1_sent = True
   Else
      M2_sent = True
   End If
Return

Repeat:                                 ' neuer Versuch
   Incr Error
   If Error < 5 Then          ' bei 5 Fehlversuchen wird abgebrochen
      Goto Send_message
   Else
      Print #1 , "No connection possible."
      Goto Eop
   End If

Eop:                                    ' Programmende
   Close #1
   End