'-------------------------------------------------------------------
' iButton DS1920 Temperaturmessung
'-------------------------------------------------------------------
$regfile = "m8def.dat"                                      ' ATmega8
$crystal = 3686400                                          ' fr STK500
$baud = 9600

Config 1wire = Portb.0                                      ' PB0 ist 1-Wire Busleitung

Const Parasitpower = 1                                      ' Spannungsversorgung ber 1-Wire Bus
Const Ds1920 = &H10
Const Skiprom = &HCC                                        ' berspringe ROM Kommandos
Const Read_rom = &H33                                       ' Lese ROM
Const Convertt = &H44                                       ' Start Temperaturmessung
Const Read_ram = &HBE                                       ' Lese Scratchpad RAM
Const Write_ram = &H4E                                      ' Schreibe Scratchpad RAM
Const Copy_ram = &H48                                       ' Kopiere Scratchpad RAM
Const Recall_ee = &HB8                                      ' Kopiere EEPROM nach RAM
Const Read_power = &HB4                                     ' Abfrage Spannung (nur DS1820)

Dim Family_code As Byte                                     ' Family Code = &H10 fr DS1820 und DS1920
Dim Serial_number(6) As Byte                                ' iButton Seriennummer
Dim Crc As Byte                                             ' DS1920 CRC
Dim Scratch(9) As Byte                                      ' Scratchpad RAM Kopie
Dim I As Byte                                               ' Index
Dim Temp As Word                                            ' Temperaturwert
Dim Temp1 As Integer
Dim Stemp As Single

Do
   1wreset                                                  ' Reset iButton
   If Err = 1 Then Print "iButton ERROR"
   1wwrite Read_rom                                         ' Lese ROM Kommando
   Family_code = 1wread()                                   ' Auslesen ROM Inhalt
   For I = 1 To 6
      Serial_number(i) = 1wread()
   Next
   Crc = 1wread()
   If Family_code <> Ds1920 Then Exit Do
   1wwrite Convertt                                         ' starte Temperaturmessung
#if Parasitpower
   Wait 2                                                   ' warte Temperaturmessung ab
#else
   Do                                                       ' DS1820 mit VDD
   Temp = 1wread()
   Loop Until Temp = &HFF                                   ' warte bis Temperaturmessung beendet ist
#endif
   1wreset                                                  ' Reset iButton
   If Err = 1 Then Print "iButton ERROR"
   1wwrite Skiprom                                          ' berspringe Adressierung
   1wwrite Read_ram                                         ' lese Scratch Pad
   For I = 1 To 9
      Scratch(i) = 1wread()
   Next
   Temp = Scratch(2)
   Shift Temp , Left , 8
   Temp = Temp + Scratch(1)                                 ' Word Format
   Temp1 = Temp                                             ' Integer Format
   Print "Der Temperaturwert ist " ; Temp ; " Counts."
   Temp1 = Temp1 / 2
   Print "Die gemessene Temperatur ist " ; Temp1 ; " Grad Celsius"
   Stemp = Scratch(8) - Scratch(7)                          ' Interpolation
   Stemp = Stemp / Scratch(8)
   Stemp = Stemp + Temp1
   Stemp = Stemp - 0.25
   Print "Die exakt gemessene Temperatur ist ";
   Print Fusing(stemp , "#.##");
   Print " Grad Celsius"
   Wait 2
Loop

Print "Kein Temperatursensor kontaktiert"

End