 $regfile = "m8def.dat"                  ' ATmega8
$crystal = 3686400                      ' fr STK500
$baud = 19200

' Folgende SMS sind im Handy abzulegen
' SMS #1: Anlage scharf
' SMS #2: S1 offen
' SMS #3: S2 offen
' SMS #4: Anlage ausser Betrieb

Const True = 1
Const False = 0

Const Instruct = 254
Const Setcursor = 71                    ' [x] [y]
Const Cursorhome = 72
Const Cleardisplay = 88

Declare Function Read_gsm(byval Mask As String) As Byte

Dim Status As Byte
Dim M1_sent As Bit
Dim M2_sent As Bit

Open "Comb.0:19200,8,N,1,inverted" For Output As #1   ' PB0 ist ser. Ausgang
Wait 1
Print #1 , Chr(instruct) ; Chr(cleardisplay);
Print #1 , "Initialisierung"

Config Pind.2 = Input                   ' S1
Config Pind.3 = Input                   ' S2
Config Pind.7 = Input                   ' S3
Portd = 255                             ' PullUp aktiv

Config Serialin = Buffered , Size = 40  ' Konfig. der ser. Eingabe
Enable Interrupts

Print #1 , Chr(instruct) ; Chr(setcursor) ; Chr(1) ; Chr(2);
Print #1 , "GSM ";
Print "AT"
Status = Read_gsm( "OK")
If Status <> 0 Then
   Print #1 , "aktiv" ;
   Wait 1
Else
   Print #1 , "nicht aktiv" ;
   Wait 1
   Goto Eop1
End If

Print #1 , Chr(instruct) ; Chr(cleardisplay);
Print #1 , "Anlage scharf..."
Print "AT+CMSS=1"                       ' Sende SMS #1
M1_sent = False
M2_sent = False

Do
   If Pind.2 = 0 Then
      If M1_sent <> True Then
         Gosub Send_message2
      End If
   Else
      M1_sent = False
      Print #1 , Chr(instruct) ; Chr(setcursor) ; Chr(1) ; Chr(3);
      Print #1 , "S1 geschlossen";
   End If
   If Pind.3 = 0 Then
      If M2_sent <> True Then
         Gosub Send_message3
      End If
   Else
      M2_sent = False
      Print #1 , Chr(instruct) ; Chr(setcursor) ; Chr(1) ; Chr(4);
      Print #1 , "S2 geschlossen";
   End If
   If Pind.7 = 0 Then Exit Do
   Waitms 500
Loop

Eop1:
Print #1 , Chr(instruct) ; Chr(cleardisplay);
Print #1 , "Anlage"
Print #1 , "ausser Betrieb.";
Print "AT+CMSS=4"                       ' Sende SMS #4
Goto Eop                                ' Programmende

Send_message2:
   Print #1 , Chr(instruct) ; Chr(setcursor) ; Chr(1) ; Chr(3);
   Print #1 , "S1 offen      " ;
   Print "AT+CMSS=2"                    ' Sende SMS #2
   M1_sent = True
Return

Send_message3:
   Print #1 , Chr(instruct) ; Chr(setcursor) ; Chr(1) ; Chr(4);
   Print #1 , "S2 offen      ";
   Print "AT+CMSS=3"                    ' Sende SMS #3
   M2_sent = True
Return

Eop:
Close #1               ' Close #1 muss nach letztem Print #1 stehen!
End

Function Read_gsm(byval Mask As String) As Byte
   Local In$ As String * 20
   Local C As Byte

   In$ = ""
   Wait 1
   While Ischarwaiting() <> 0
      C= inkey()
      In$ = In$ + Chr(c)
   Wend
   Read_gsm = Instr(in$ , Mask)
End Function