$regfile = "m8def.dat"                                      ' ATmega8
$crystal = 3690000                                          ' fr STK500
$baud = 19200

Const Phone = "+49351xxxxxx8"                               ' zu whlende Telefonnummer
Const Message = "Notstopp"                                  ' zu versendende Mitteilung

Const Instruct = 254
Const Setcursor = 71                                        ' [x] [y]
Const Cursorhome = 72
Const Cleardisplay = 88

Dim Rc_string As String * 20
Dim Status As Byte
Dim Error As Byte

Open "Comb.0:19200,8,N,1,inverted" For Output As #1         ' PB0 ist ser. Ausgang
Wait 1
Print #1 , Chr(instruct) ; Chr(cleardisplay);
Print #1 , "Initialisierung"

Config Pind.2 = Input
Config Serialin = Buffered , Size = 40                      ' Konfig. der ser. Eingabe
Enable Interrupts

Do
   Bitwait Pind.2 , Reset                                   ' Warte bis PD2 Lo ist
   Bitwait Pind.2 , Set                                     ' Warte bis PD2 wieder Hi ist

M1:
   Print "ATZ"                                              ' Initialisiere Modem mit Werkseinstellung
   Input Rc_string                                          ' Warte auf Antwort vom Modem
   Status = Instr(rc_string , "OK")                         ' hat Modem mit OK geantwortet?
   If Status = 0 Then
      Print #1 , "Connection failed."
      Goto Repeat
   End If

   Print "ATE"                                              ' Echo ausschalten
   Input Rc_string                                          ' Warte auf Antwort vom Modem
   Status = Instr(rc_string , "OK")                         ' hat Modem mit OK geantwortet?
   If Status = 0 Then
      Print #1 , "Connection failed."
      Goto Repeat
   End If

   Wait 2

   Print "ATDT";
   Print Phone                                              ' Whle Telefonnummer
   Input Rc_string
   Status = Instr(rc_string , "CONNECT")                    ' hat Modem mit CONNECT geantwortet?
   If Status = 0 Then
      Print #1 , "Connection failed."
      Goto Repeat
   End If

   Wait 2

   Print Message                                            ' Sende Mitteilung

   Wait 3                                                   ' wird fr +++ Kommando bentigt
   Print "+++"                                              ' Umschalten in Kommandomode
   Wait 2                                                   ' wird fr +++ Kommando bentigt

   Print "ATH"                                              ' Unterbrechen der Verbindung
   Input Rc_string                                          ' Warte auf Antwort vom Modem
   Status = Instr(rc_string , "OK")                         ' hat Modem mit OK geantwortet?
   If Status = 0 Then
      Print #1 , "Connection failed."
      Goto Repeat
   End If
Loop

Repeat:                                                     ' neuer Versuch
   Incr Error
   If Error < 5 Then                                        ' bei 5 Fehlversuchen wird abgebrochen
      Goto M1
   Else
      Print #1 , "No connection possible."
      Goto Eop
   End If

Eop:                                                        ' Programmende
   Close #1
   End